##==============================================================================
##	File:     $URL$
##	Version:  $Revision$
##	Author:   John Wawrzynek
##	Copyright: Copyright 2009 UC Berkeley
##==============================================================================

##==============================================================================
##	Section:	License
##==============================================================================
##	Copyright (c) 2005-2009, Regents of the University of California
##	All rights reserved.
##
##	Redistribution and use in source and binary forms, with or without modification,
##	are permitted provided that the following conditions are met:
##
##		- Redistributions of source code must retain the above copyright notice,
##			this list of conditions and the following disclaimer.
##		- Redistributions in binary form must reproduce the above copyright
##			notice, this list of conditions and the following disclaimer
##			in the documentation and/or other materials provided with the
##			distribution.
##		- Neither the name of the University of California, Berkeley nor the
##			names of its contributors may be used to endorse or promote
##			products derived from this software without specific prior
##			written permission.
##
##	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
##	ANY EXPRESS OR InIMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE InIMPLIED
##	WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
##	DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
##	ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
##	(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
##	LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
##	ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
##	(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
##	SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
##==============================================================================

## Simple program that outputs a greeting
##  then echos console input output
##
## This version is missing code to handle
##  branch and load delay slots.

__start:
	ori $sp, $0, 0x7ffff	# initalize stack pointer
	sll $sp, $sp, 12
L:	jal	inchar				# get char from console
	or	$a0, $0, $v0		# move to argument list
	jal	outchar				# put char to console
	beq	$0, $0,	L			# repeat forever


#
# console I/O routines
#
inchar:
	addiu	$sp, $sp, -4	# save return address
	sw	$ra, 0($sp)
	ori	$t0, $0, 0xffff		# form control register address
	sll	$t0, $t0, 16		# t0 <- 0xffff_0000
L0:	lw	$t1, 0($t0)			# get control register
	andi	$t1, $t1, 0x1	# check if ready
	beq	$t1, $0, L0			# then wait if not
	lw	$v0, 4($t0)			# get the byte
	lw	$ra, 0($sp)			# restore return address
	addi	$sp, $sp, 4		# and stack pointer
	jr	$ra					# return


outchar:
	addiu $sp, $sp, -4		# save return address
	sw	$ra, 0($sp)
	ori	$t0, $0, 0xffff		# form control register address
	sll	$t0, $t0, 16		# t0 <- 0xffff_0000
L1:	lw	$t1, 8($t0)			# get control register
	andi	$t1, $t1, 0x1	# check if ready
	beq	$t1, $0, L1			# then wait if not
	sw	$a0, 12($t0)		# put the byte
	lw	$ra, 0($sp)			# restore return address
	addiu	$sp, $sp, 4		# and stack pointer
	jr	$ra					# return
